## ioquake3 1.36%2Bu20191029.dc0c3e7~dfsg

=== debian/changelog ===
ioquake3 (1.36+u20191029.dc0c3e7~dfsg-1) unstable; urgency=medium

  * Standards-Version: 4.4.1 (no changes required)
  * New upstream snapshot

 -- Simon McVittie <smcv@debian.org>  Sat, 02 Nov 2019 11:54:24 +0000

ioquake3 (1.36+u20190529.350b8f9~dfsg-2) unstable; urgency=medium

  * Upload to unstable
  * d/salsa-ci.yml: Request standard CI on salsa.debian.org
  * d/rules: Remove migration path from ioquake3-dbg, which was not
    in stretch or buster
  * Standards-Version: 4.4.0 (no changes required)

 -- Simon McVittie <smcv@debian.org>  Tue, 09 Jul 2019 17:19:54 +0100

ioquake3 (1.36+u20190529.350b8f9~dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * d/copyright: Update
  * d/patches: Refresh

 -- Simon McVittie <smcv@debian.org>  Wed, 12 Jun 2019 22:18:37 +0100

ioquake3 (1.36+u20190416.d13d064~dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * d/p/lightall_fp.glsl-Stub-out-USE_BOX_CUBEMAP_PARALLAX-on-GLS.patch:
    Drop, replaced by a slightly different upstream solution

 -- Simon McVittie <smcv@debian.org>  Sun, 21 Apr 2019 21:55:22 +0100

ioquake3 (1.36+u20190206.d068e1d~dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * d/p/lightall_fp.glsl-Stub-out-USE_BOX_CUBEMAP_PARALLAX-on-GLS.patch:
    Mark patch as forwarded
  * AppArmor: Mark Mesa shader cache rules as obsoleted by apparmor 2.13
  * Use debhelper-compat (= 12)

 -- Simon McVittie <smcv@debian.org>  Sun, 17 Mar 2019 17:09:49 +0000

ioquake3 (1.36+u20181222.e5da13f~dfsg-2) unstable; urgency=medium

  * d/p/lightall_fp.glsl-Stub-out-USE_BOX_CUBEMAP_PARALLAX-on-GLS.patch:
    Fix shader compilation on hardware that doesn't support GLSL 1.30,
    and in particular pre-2011 Intel GPUs (5th generation, "Ironlake",
    or older). (Closes: #923226)

 -- Simon McVittie <smcv@debian.org>  Fri, 08 Mar 2019 09:09:43 +0000

ioquake3 (1.36+u20181222.e5da13f~dfsg-1) unstable; urgency=medium

  * New upstream snapshot
  * Declare compliance with Debian Policy 4.3.0

 -- Simon McVittie <smcv@debian.org>  Mon, 14 Jan 2019 08:29:04 +0000

ioquake3 (1.36+u20181017.09166ba~dfsg-2) unstable; urgency=medium

  * Explicitly set COMPILE_ARCH, COMPILE_PLATFORM as well as ARCH and
    PLATFORM.
    Otherwise the build system will think we're cross-compiling on any
    non-special-cased architecture where uname -m doesn't match the CPU
    part of the GNU tuple (mips64el, ppc64el, hppa, sh4 and hurd-i386
    have this behaviour), which in recent snapshots causes the upstream
    build system to reject pkg-config.
  * Clear ALTIVEC_CFLAGS on powerpcspe as intended
  * Explicitly set PKG_CONFIG, even when not cross-compiling
  * Only evaluate OPTIONS on-demand

 -- Simon McVittie <smcv@debian.org>  Tue, 13 Nov 2018 01:23:47 +0000

ioquake3 (1.36+u20181017.09166ba~dfsg-1) unstable; urgency=medium

  * New upstream snapshot
  * Don't install the upstream ChangeLog, which is 10 years out of date

 -- Simon McVittie <smcv@debian.org>  Mon, 12 Nov 2018 15:52:28 +0000

ioquake3 (1.36+u20180915.33a899d~dfsg-1) unstable; urgency=medium

  * d/p/debian/Compile-successfully-against-libcurl-7.52.x.patch:
    Don't rely on such a recent libcurl, to facilitate backporting to
    Debian 9 'stretch'
  * New upstream snapshot
  * Revert "Update maintainer address". The lists.alioth.debian.org
    form is still the canonical one.

 -- Simon McVittie <smcv@debian.org>  Mon, 01 Oct 2018 15:07:34 +0100

ioquake3 (1.36+u20180828.29db640~dfsg-1) unstable; urgency=medium

  * New upstream snapshot
  * Rename AppArmor profiles to decouple the name from the attachment,
    as per
    https://lists.ubuntu.com/archives/apparmor/2018-August/011791.html
  * d/copyright: Update for files in debian/
  * Declare compliance with Debian Policy 4.2.1

 -- Simon McVittie <smcv@debian.org>  Fri, 31 Aug 2018 11:30:45 +0100

ioquake3 (1.36+u20180720.39e2113~dfsg-1) unstable; urgency=medium

  * Update maintainer address
  * New upstream snapshot
    - d/p/Allow-pkg-config-binary-to-be-overridden-with-PKG_CONFIG.patch:
      Drop, applied upstream
  * Declare compliance with Debian Policy 4.1.5

 -- Simon McVittie <smcv@debian.org>  Wed, 25 Jul 2018 11:27:10 +0100

ioquake3 (1.36+u20180610.38a2f4d~dfsg-1) unstable; urgency=medium

  * d/p/Allow-pkg-config-binary-to-be-overridden-with-PKG_CONFIG.patch:
    Use $(PKG_CONFIG) in preference to pkg-config, for cross-compilation
    (a multiarch libopusfile-dev is also required, see #899138)
  * New upstream snapshot
    - d/p/Disable-Altivec-instructions-on-PowerPC-unless-requested.patch:
      Drop patch, superseded by upstream changes that should make runtime
      detection work as it was intended to
    - d/rules: Explicitly disable Altivec on powerpcspe

 -- Simon McVittie <smcv@debian.org>  Tue, 12 Jun 2018 11:25:10 +0100

ioquake3 (1.36+u20180506.10abac8~dfsg-1) unstable; urgency=medium

  * New upstream snapshot
  * Refresh patches

 -- Simon McVittie <smcv@debian.org>  Fri, 11 May 2018 11:16:31 +0100

ioquake3 (1.36+u20180409.3ad427c~dfsg-1) unstable; urgency=medium

  * Use uscan in git mode to download orig tarballs
  * New upstream snapshot
  * Declare compliance with Debian Policy 4.1.4

 -- Simon McVittie <smcv@debian.org>  Mon, 09 Apr 2018 10:31:45 +0100

ioquake3 (1.36+u20180322~dfsg-1) unstable; urgency=medium

  * New upstream snapshot
    - Appears to have fixed rare crashes in bot routing around
      OpenArena's oa_dm1 (Closes: #607178)
  * d/copyright: Add Files-Excluded

 -- Simon McVittie <smcv@debian.org>  Mon, 26 Mar 2018 22:46:26 +0100

ioquake3 (1.36+u20180108~dfsg-2) unstable; urgency=medium

  * Add reference to #885839 in previous changelog entry
  * Use <abstractions/wayland> from apparmor (>= 2.10.95-5) instead
    of reinventing it
  * AppArmor: Allow reading EGL vendor configuration
  * AppArmor: Allow zenity to read from dconf
  * Move packaging to salsa.debian.org

 -- Simon McVittie <smcv@debian.org>  Mon, 15 Jan 2018 08:35:54 +0000


